{17.12.1999}

unit AMHRollUp;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, Buttons;

type
  TRollUpState = (rsUp, rsDown);

  TRollUpTitel = class(TCustomPanel)
  private
    { Private-Deklarationen }
    Button: TSpeedButton;
    procedure UpDown(Sender: TObject);
  protected
    { Protected-Deklarationen }
    constructor Create(AOwner: TComponent); override;
    DESTRUCTOR Destroy; OVERRIDE;
    Procedure Paint(Var Message: TWMPaint); Message WM_PAINT;
    Procedure Size (Var Message: TWMSize);  Message WM_Size;
    Procedure ButtonDown(Var Message: TWMLButtonDown);  Message WM_LBUTTONDOWN;
  public
    { Public-Deklarationen }
  published
    { Published-Deklarationen }
  end;

  TGlyphStyle = (gsSimpel, gsStyle);

  TRollUp = class(TCustomPanel)
  private
    { Private-Deklarationen }
    Titel       : TRollUpTitel;
    FGlyphDown,
    FGlyphUp    : TBitmap;
    FTitleFont  : TFont;
    FCaption    : String;
    FState      : TRollUpState;
    FOldHeight  : Integer;
    procedure SetCaption(ACaption: String);
    procedure SetState(AState: TRollUpState);
  protected
    { Protected-Deklarationen }
    constructor Create(AOwner: TComponent); override;
    DESTRUCTOR Destroy; OVERRIDE;
    Procedure Paint(Var Message: TWMPaint); Message WM_PAINT;
    Procedure Size (Var Message: TWMSize);  Message WM_Size;
  public
    { Public-Deklarationen }
    Property Font;
  published
    { Published-Deklarationen }
    Property Caption: String Read FCaption Write SetCaption;
    Property BorderStyle;
    Property TitleFont: TFont Read FTitleFont Write FTitleFont;
    Property State: TRollUpState Read FState Write SetState Default rsDown;
    Property OldHeight: Integer Read FOldHeight Write FOldHeight;
    property GlyphDown: TBitmap read FGlyphDown write FGlyphDown;
    property GlyphUp  : TBitmap read FGlyphUp   write FGlyphUp;
  end;

procedure Register;

implementation

constructor TRollUpTitel.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Parent      := TWinControl(AOwner);
  Align       := alTop;
  Alignment   := taLeftJustify;
  BevelOuter  := bvNone;
  BorderWidth := 1;
  Color       := clHighlight;
  Font.Color  := clHighlightText;
  Button := TSpeedButton.Create(Self);
  Button.OnClick := UpDown;
  Button.Parent := Self;
  Button.Align := alRight;
end;

DESTRUCTOR TRollUpTitel.Destroy;
BEGIN
  If Assigned(Button) Then Button.Free;
  INHERITED Destroy;
END;  { Destroy }

procedure TRollUpTitel.UpDown(Sender: TObject);
begin
  If TRollUp(Parent).State = rsDOWN Then
    TRollUp(Parent).State := rsUP
  Else
    TRollUp(Parent).State := rsDOWN;
end;

Procedure TRollUpTitel.Paint(Var Message: TWMPaint);
Begin
  inherited;
  Height :=   Canvas.TextHeight('X') + 2 * BorderWidth;
  Button.Width := Button.Height + Button.Height Mod 2;
End;

Procedure TRollUpTitel.Size(Var Message: TWMSize);
Begin
  inherited;
  SendMessage(Canvas.Handle, WM_PAINT, 0, 0);
End;

Procedure TRollUpTitel.ButtonDown(Var Message: TWMLButtonDown);
Begin
  inherited;
  releasecapture;
  sendmessage(Parent.Handle, WM_NCLBUTTONDOWN, 2, 0);
End;

constructor TRollUp.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Parent      := TWinControl(AOwner);
  BorderWidth := 1;
  Width       := 150;
  Height      := 150;
  OldHeight   := Height;

  Titel             := TRollUpTitel.Create(Self);
  Titel.Font.Style  := [fsBold];
  FTitleFont        := Titel.Font;

  State             := rsDown;

  FGlyphUp          := TBitmap.Create;
  FGlyphUp.Handle   := LoadBitmap(HInstance, 'ROLL_UP');
  FGlyphDown        := TBitmap.Create;
  FGlyphDown.Handle := LoadBitmap(HInstance, 'ROLL_DOWN');
  Caption := Self.Name;
end;

DESTRUCTOR TRollUp.Destroy;
BEGIN
  If Assigned(Titel) Then Titel.Free;
  INHERITED Destroy;
END;  { Destroy }

Procedure TRollUp.Paint(Var Message: TWMPaint);
Begin
  inherited;
  If FState = rsUP Then Begin
    Titel.Button.Glyph := FGlyphUP
  End Else Begin
    Titel.Button.Glyph := FGlyphDown;
  End;
  Titel.Button.NumGlyphs := 1;
  Titel.Button.Invalidate;
End;

Procedure TRollUp.Size(Var Message: TWMSize);
Begin
  If FState = rsDown Then Begin
    inherited;
    OldHeight := Height;
  End;
  SendMessage(Canvas.Handle, WM_PAINT, 0, 0);
End;

procedure TRollUp.SetCaption(ACaption: String);
Begin
  FCaption := ACaption;
  Titel.Caption := ' ' + FCaption;
  Titel.ReFresh;
End;

procedure TRollUp.SetState(AState: TRollUpState);
Begin
  FState := AState;
  If AState = rsUP Then Height := Titel.Height + 2 * Titel.Top
                   Else Height := OldHeight;
End;

procedure Register;
begin
  RegisterComponents('AMH Free', [TRollUp]);
end;

end.
